C     ORGANON GROWTH AND YIELD MODEL
C     SUBROUTINES INCLUDED:
C         DG_SWO
C         DG_NWO
C         DG_SMC
C         DG_RAP
C         PM_SWO
C         PM_NWO
C         PM_SMC
C         PM_RAP
C         HD_NWO
C         HD_SMC
C         HCB_NWO
C         HCB_SMC
C         MCW_SWO
C         MCW_NWO
C         MCW_SMC
C         MCW_RAP
********************************************************************************
      SUBROUTINE DG_SWO(ISPGRP,DBH,CR,SITE,SBAL1,SBA1,DG)
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4 B0,B1,B2,B3,B4,B5,B6,K1,K2,K3,K4,DBH,CR,SITE,SBAL1,SBA1,
     1       LNDG,DG,DGPAR(18,11),CRADJ,ADJ
C
C  DIAMETER GROWTH PARAMETERS FOR SOUTHWEST OREGON (11 parameters - all species)
C
C     DF Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     GW Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     PP Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     SP Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     IC Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     WH Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     RC Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #2
C     PY Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     MD Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     GC Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     TA Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     CL Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     BL Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     WO Coefficients from Gould, Marshall, and Harrington (2008) West. J. Appl. For. 23: 26-33
C     BO Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     RA Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #1
C     PD Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     WI Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C
      DATA DGPAR/
     1             -5.35558894,     -5.84904111,     -4.51958940,      !  DF,GW,PP
     1             -4.12342552,     -2.08551255,     -5.70052255,      !  SP,IC,WH
     1            -11.45456097,     -9.15835863,     -8.84531757,      !  RC,PY,MD
     1             -7.78451344,     -3.36821750,     -3.59333060,      !  GC,TA,CL
     1             -3.41449922,     -7.81267986,     -4.43438109,      !  BL,WO,BO
     1             -4.39082007,     -8.08352683,     -8.08352683,      !  RA,PD,WI
C
     2              0.840528547,     1.668196109,     0.813998712,     !  DF,GW,PP
     2              0.734988422,     0.596043703,     0.865087036,     !  SP,IC,WH
     2              0.784133664,     1.0        ,     1.5        ,     !  RC,PY,MD
     2              1.2        ,     1.2        ,     1.2        ,     !  GC,TA,CL
     2              1.0        ,     1.405616529,     0.930930363,     !  BL,WO,BO
     2              1.0        ,     1.0        ,     1.0        ,     !  RA,PD,WI
C
     3             -0.0427481848,   -0.0853271265,   -0.0493858858,    !  DF,GW,PP
     3             -0.0425469735,   -0.0215223077,   -0.0432543518,    !  SP,IC,WH
     3             -0.0261377888,   -0.00000035  ,   -0.0006      ,    !  RC,PY,MD
     3             -0.07        ,   -0.07        ,   -0.07        ,    !  GC,TA,CL
     3             -0.05        ,   -0.0603105850,   -0.0465947242,    !  BL,WO,BO
     3             -0.0945057147,   -0.00000035  ,   -0.00000035  ,    !  RA,PD,WI
C
     4              1.15950313  ,    1.21222176  ,    1.10249641  ,    !  DF,GW,PP
     4              1.05942163  ,    1.02734556  ,    1.10859727  ,    !  SP,IC,WH
     4              0.70174783  ,    1.16688474  ,    0.51225596  ,    !  RC,PY,MD
     4              0.0         ,    0.0         ,    0.51637418  ,    !  GC,TA,CL
     4              0.0         ,    0.64286007  ,    0.0         ,    !  BL,WO,BO
     4              1.06867026  ,    0.31176647  ,    0.31176647  ,    !  RA,PD,WI
C
     5              0.954711126 ,    0.679346647 ,    0.879440023 ,    !  DF,GW,PP
     5              0.808656390 ,    0.383450822 ,    0.977332597 ,    !  SP,IC,WH
     5              2.057236260 ,    0.0         ,    0.418129153 ,    !  RC,PY,MD
     5              1.01436101  ,    0.0         ,    0.0         ,    !  GC,TA,CL
     5              0.324349277 ,    1.037687142 ,    0.510717175 ,    !  BL,WO,BO
     5              0.685908029 ,    0.0         ,    0.0         ,    !  RA,PD,WI
C
     6             -0.00894779670,  -0.00809965733,  -0.0108521667,    !  DF,GW,PP
     6             -0.0107837565 ,  -0.00489046624,   0.0         ,    !  SP,IC,WH
     6             -0.00415440257,   0.0          ,  -0.00355254593,   !  RC,PY,MD
     6             -0.00834323811,   0.0          ,   0.0          ,   !  GC,TA,CL
     6              0.0          ,   0.0          ,   0.0          ,   !  BL,WO,BO
     6             -0.00586331028,   0.0          ,   0.0          ,   !  RA,PD,WI
C
     7              0.0         ,    0.0         ,   -0.0333706948,    !  DF,GW,PP
     7              0.0         ,   -0.0609024782,   -0.0526263229,    !  SP,IC,WH
     7              0.0         ,   -0.02        ,   -0.0321315389,    !  RC,PY,MD
     7              0.0         ,   -0.0339813575,   -0.02        ,    !  GC,TA,CL
     7             -0.0989519477,   -0.0787012218,   -0.0688832423,    !  BL,WO,BO
     7              0.0         ,   -0.0730788052,   -0.0730788052,    !  RA,PD,WI
C
     8              5.0         ,    5.0         ,    5.0         ,    !  DF,GW,PP
     8              5.0         ,    5.0         ,    5.0         ,    !  SP,IC,WH
     8              5.0         , 4000.0         ,  110.0         ,    !  RC,PY,MD
     8             10.0         ,   10.0         ,   10.0         ,    !  GC,TA,CL
     8             10.0         ,    5.0         ,    5.0         ,    !  BL,WO,BO
     8              5.0         , 4000.0         , 4000.0         ,    !  RA,PD,WI
C
     9              1.0         ,    1.0         ,    1.0         ,    !  DF,GW,PP
     9              1.0         ,    1.0         ,    1.0         ,    !  SP,IC,WH
     9              1.0         ,    4.0         ,    2.0         ,    !  RC,PY,MD
     9              1.0         ,    1.0         ,    1.0         ,    !  GC,TA,CL
     9              1.0         ,    1.0         ,    1.0         ,    !  BL,WO,BO
     9              1.0         ,    4.0         ,    4.0         ,    !  RA,PD,WI
C
     X              1.0         ,    1.0         ,    1.0         ,    !  DF,GW,PP
     X              1.0         ,    1.0         ,    1.0         ,    !  SP,IC,WH
     X              1.0         ,    1.0         ,    1.0         ,    !  RC,PY,MD
     X              1.0         ,    1.0         ,    1.0         ,    !  GC,TA,CL
     X              1.0         ,    1.0         ,    1.0         ,    !  BL,WO,BO
     X              1.0         ,    1.0         ,    1.0         ,    !  RA,PD,WI
C
     A              2.7         ,    2.7         ,    2.7         ,    !  DF,GW,PP
     A              2.7         ,    2.7         ,    2.7         ,    !  SP,IC,WH
     A              2.7         ,    2.7         ,    2.7         ,    !  RC,PY,MD
     A              2.7         ,    2.7         ,    2.7         ,    !  GC,TA,CL
     A              2.7         ,    2.7         ,    2.7         ,    !  BL,WO,BO
     A              2.7         ,    2.7         ,    2.7/             !  RA,PD,WI
C
      B0=DGPAR(ISPGRP,1)
      B1=DGPAR(ISPGRP,2)
      B2=DGPAR(ISPGRP,3)
      B3=DGPAR(ISPGRP,4)
      B4=DGPAR(ISPGRP,5)
      B5=DGPAR(ISPGRP,6)
      B6=DGPAR(ISPGRP,7)
      K1=DGPAR(ISPGRP,8)
      K2=DGPAR(ISPGRP,9)
      K3=DGPAR(ISPGRP,10)
      K4=DGPAR(ISPGRP,11)
      LNDG=B0
     1      +B1*LOG(DBH+K1)
     2      +B2*DBH**K2
     3      +B3*LOG((CR+0.2)/1.2)
     4      +B4*LOG(SITE)
     5      +B5*((SBAL1**K3)/LOG(DBH+K4))
     6      +B6*SQRT(SBA1)
C
C     CROWN RATIO ADJUSTMENT
C
      CRADJ=1.0-EXP(-(25.0*CR)**2)
      IF(ISPGRP .EQ. 1) THEN
         ADJ=0.8938
      ELSEIF(ISPGRP .EQ. 2) THEN
         ADJ=0.8722
      ELSEIF(ISPGRP .EQ. 4) THEN
         ADJ=0.7903
      ELSEIF(ISPGRP .EQ. 9) THEN
         ADJ=0.7928
      ELSEIF(ISPGRP .EQ. 10) THEN
         ADJ=0.7259
      ELSEIF(ISPGRP .EQ. 14) THEN
         ADJ=1.0
      ELSEIF(ISPGRP .EQ. 15) THEN
         ADJ=0.7667
      ELSE
         ADJ=0.8
      ENDIF
      DG=EXP(LNDG)*CRADJ*ADJ
      RETURN
      END
*******************************************************************************
      SUBROUTINE DG_NWO(ISPGRP,DBH,CR,SITE,SBAL1,SBA1,DG)
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4 B0,B1,B2,B3,B4,B5,B6,K1,K2,K3,K4,DBH,CR,SITE,SBAL1,SBA1,
     1       LNDG,DG,DGPAR(11,11),CRADJ,ADJ
C
C  DIAMETER GROWTH (11 parameters - all species)
C
C     DF Coefficients from Zumrawi and Hann (1993) FRL Research Contribution 4
C     GF Coefficients from Zumrawi and Hann (1993) FRL Research Contribution 4
C     WH Coefficients from Johnson (2002) Willamette Industries Report
C     RC Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #2
C     PY Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     MD Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     BL Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     WO Coefficients from Gould, Marshall, and Harrington (2008) West. J. Appl. For. 23: 26-33
C     RA Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #1
C     PD Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     WI Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C
      DATA DGPAR/
     1          -4.69624      ,     -2.34619      ,     -4.49867      ,! DF,GF,WH
     1         -11.45456097   ,     -9.15835863   ,     -8.84531757   ,! RC,PY,MD
     1          -3.41449922   ,     -7.81267986   ,     -4.39082007   ,! BL,WO,RA
     1          -8.08352683   ,     -8.08352683   ,                    ! PD,WI
C
     2           0.339513     ,      0.594640     ,      0.362369     ,! DF,GF,WH
     2           0.784133664  ,      1.0          ,      1.5          ,! RC,PY,MD
     2           1.0          ,      1.405616529  ,      1.0          ,! BL,WO,RA
     2           1.0          ,      1.0          ,                    ! PD,WI
C
     3          -0.000428261  ,     -0.000976092  ,     -0.00153907   ,! DF,GF,WH
     3          -0.0261377888 ,     -0.00000035   ,     -0.0006       ,! RC,PY,MD
     3          -0.05         ,     -0.0603105850 ,     -0.0945057147 ,! BL,WO,RA
     3          -0.00000035   ,     -0.00000035   ,                    ! PD,WI
C
     4           1.19952      ,      1.12712      ,      1.1557       ,! DF,GF,WH
     4           0.70174783   ,      1.16688474   ,      0.51225596   ,! RC,PY,MD
     4           0.0          ,      0.64286007   ,      1.06867026   ,! BL,WO,RA
     4           0.31176647   ,      0.31176647   ,                    ! PD,WI
C
     5           1.15612      ,      0.555333     ,      1.12154      ,! DF,GF,WH
     5           2.057236260  ,      0.0          ,      0.418129153  ,! RC,PY,MD
     5           0.324349277  ,      1.037687142  ,      0.685908029  ,! BL,WO,RA
     5           0.0          ,      0.0          ,                    ! PD,WI
C
     6          -0.0000446327 ,     -0.0000290672 ,     -0.0000201041 ,! DF,GF,WH
     6          -0.00415440257,      0.0          ,     -0.00355254593,! RC,PY,MD
     6           0.0          ,      0.0          ,     -0.00586331028,! BL,WO,RA
     6           0.0          ,      0.0          ,                    ! PD,WI
C
     7          -0.0237003    ,     -0.0470848    ,     -0.0417388    ,! DF,GF,WH
     7           0.0          ,     -0.02         ,     -0.0321315389 ,! RC,PY,MD
     7          -0.0989519477 ,     -0.0787012218 ,      0.0          ,! BL,WO,RA
     7          -0.0730788052 ,     -0.0730788052 ,                    ! PD,WI
C
     8           1.0          ,      1.0          ,      1.0          ,! DF,GF,WH
     8           5.0          ,   4000.0          ,    110.0          ,! RC,PY,MD
     8          10.0          ,      5.0          ,      5.0          ,! BL,WO,RA
     8        4000.0          ,   4000.0          ,                    ! PD,WI
C
     9           2.0          ,      2.0          ,      2.0          ,! DF,GF,WH
     9           1.0          ,      4.0          ,      2.0          ,! RC,PY,MD
     9           1.0          ,      1.0          ,      1.0          ,! BL,WO,RA
     9           4.0          ,      4.0          ,                    ! PD,WI
C
     X           2.0          ,      2.0          ,      2.0          ,! DF,GF,WH
     X           1.0          ,      1.0          ,      1.0          ,! RC,PY,MD
     X           1.0          ,      1.0          ,      1.0          ,! BL,WO,RA
     X           1.0          ,      1.0          ,                    ! PD,WI
C
     A           5.0          ,      5.0          ,      5.0          ,! DF,GF,WH
     A           2.7          ,      2.7          ,      2.7          ,! RC,PY,MD
     A           2.7          ,      2.7          ,      2.7          ,! BL,WO,RA
     A           2.7          ,      2.7/                              ! PD,WI
C
      B0=DGPAR(ISPGRP,1)
      B1=DGPAR(ISPGRP,2)
      B2=DGPAR(ISPGRP,3)
      B3=DGPAR(ISPGRP,4)
      B4=DGPAR(ISPGRP,5)
      B5=DGPAR(ISPGRP,6)
      B6=DGPAR(ISPGRP,7)
      K1=DGPAR(ISPGRP,8)
      K2=DGPAR(ISPGRP,9)
      K3=DGPAR(ISPGRP,10)
      K4=DGPAR(ISPGRP,11)
      LNDG=B0
     1      +B1*LOG(DBH+K1)
     2      +B2*DBH**K2
     3      +B3*LOG((CR+0.2)/1.2)
     4      +B4*LOG(SITE)
     5      +B5*((SBAL1**K3)/LOG(DBH+K4))
     6      +B6*SQRT(SBA1)
C
C     CROWN RATIO ADJUSTMENT
C
      CRADJ=1.0-EXP(-(25.0*CR)**2)
C
      IF(ISPGRP .EQ. 1) THEN
         ADJ=0.7011014
      ELSEIF(ISPGRP .EQ. 2) THEN
         ADJ=0.8722
      ELSEIF(ISPGRP .EQ. 3) THEN
         ADJ=0.7163
      ELSEIF(ISPGRP .EQ. 6) THEN
         ADJ=0.7928
      ELSEIF(ISPGRP .EQ. 8) THEN
         ADJ=1.0
      ELSE
         ADJ=0.8
      ENDIF
      DG=EXP(LNDG)*CRADJ*ADJ
      RETURN
      END
*******************************************************************************
      SUBROUTINE DG_SMC(ISPGRP,DBH,CR,SITE,SBAL1,SBA1,DG)
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4 B0,B1,B2,B3,B4,B5,B6,K1,K2,K3,K4,DBH,CR,SBAL1,SBA1,LNDG,
     1       SITE,DG,DGPAR(11,11),CRADJ,ADJ
C
C  DIAMETER GROWTH PARAMETERS (11 parameters - all species)
C
C     DF Coefficients from Hann, Marshall, and Hanus (2006) FRL Research Contribution 49
C     GF Coefficients from Zumrawi and Hann (1993) FRL Research Contribution 4
C     WH Coefficients from Unpublished Equation on File at OSU Dept. Forest Resources
C     RC Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #2
C     PY Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     MD Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     BL Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     WO Coefficients from Gould, Marshall, and Harrington (2008) West. J. Appl. For. 23: 26-33
C     RA Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #1
C     PD Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     WI Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C
      DATA DGPAR/
     1          -5.34253119   ,     -2.34619      ,     -4.87447412   ,! DF,GF,WH
     1         -11.45456097   ,     -9.15835863   ,     -8.84531757   ,! RC,PY,MD
     1          -3.41449922   ,     -7.81267986   ,     -4.39082007   ,! BL,WO,RA
     1          -8.08352683   ,     -8.08352683   ,                    ! PD,WI
C
     2           1.098406840  ,      0.594640     ,      0.4150723209 ,! DF,GF,WH
     2           0.784133664  ,      1.0          ,      1.5          ,! RC,PY,MD
     2           1.0          ,      1.405616529  ,      1.0          ,! BL,WO,RA
     2           1.0          ,      1.0          ,                    ! PD,WI
C
     3          -0.05218621   ,     -0.000976092  ,     -0.023744997  ,! DF,GF,WH
     3          -0.0261377888 ,     -0.00000035   ,     -0.0006       ,! RC,PY,MD
     3          -0.05         ,     -0.0603105850 ,     -0.0945057147 ,! BL,WO,RA
     3          -0.00000035   ,     -0.00000035   ,                    ! PD,WI
C
     4           1.01380810   ,      1.12712      ,      0.907837299  ,! DF,GF,WH
     4           0.70174783   ,      1.16688474   ,      0.51225596   ,! RC,PY,MD
     4           0.0          ,      0.64286007   ,      1.06867026   ,! BL,WO,RA
     4           0.31176647   ,      0.31176647   ,                    ! PD,WI
C
     5           0.91202025   ,      0.555333     ,      1.1346766989 ,! DF,GF,WH
     5           2.057236260  ,      0.0          ,      0.418129153  ,! RC,PY,MD
     5           0.324349277  ,      1.037687142  ,      0.685908029  ,! BL,WO,RA
     5           0.0          ,      0.0          ,                    ! PD,WI
C
     6          -0.01756220   ,     -0.0000290672 ,     -0.015333503  ,! DF,GF,WH
     6          -0.00415440257,      0.0          ,     -0.00355254593,! RC,PY,MD
     6           0.0          ,      0.0          ,     -0.00586331028,! BL,WO,RA
     6           0.0          ,      0.0          ,                    ! PD,WI
C
     7          -0.05168923   ,     -0.0470848    ,     -0.03309787   ,! DF,GF,WH
     7           0.0          ,     -0.02         ,     -0.0321315389 ,! RC,PY,MD
     7          -0.0989519477 ,     -0.0787012218 ,      0.0          ,! BL,WO,RA
     7          -0.0730788052 ,     -0.0730788052 ,                    ! PD,WI
C
     8           6.0          ,      1.0          ,      5.0          ,! DF,GF,WH
     8           5.0          ,   4000.0          ,    110.0          ,! RC,PY,MD
     8          10.0          ,      5.0          ,      5.0          ,! BL,WO,RA
     8        4000.0          ,   4000.0          ,                    ! PD,WI
C
     9           1.0          ,      2.0          ,      1.0          ,! DF,GF,WH
     9           1.0          ,      4.0          ,      2.0          ,! RC,PY,MD
     9           1.0          ,      1.0          ,      1.0          ,! BL,WO,RA
     9           4.0          ,      4.0          ,                    ! PD,WI
C
     X           1.0          ,      2.0          ,      1.0          ,! DF,GF,WH
     X           1.0          ,      1.0          ,      1.0          ,! RC,PY,MD
     X           1.0          ,      1.0          ,      1.0          ,! BL,WO,RA
     X           1.0          ,      1.0          ,                    ! PD,WI
C
     A           2.7          ,      5.0          ,      2.7          ,! DF,GF,WH
     A           2.7          ,      2.7          ,      2.7          ,! RC,PY,MD
     A           2.7          ,      2.7          ,      2.7          ,! BL,WO,RA
     A           2.7          ,      2.7/                              ! PD,WI
C
      B0=DGPAR(ISPGRP,1)
      B1=DGPAR(ISPGRP,2)
      B2=DGPAR(ISPGRP,3)
      B3=DGPAR(ISPGRP,4)
      B4=DGPAR(ISPGRP,5)
      B5=DGPAR(ISPGRP,6)
      B6=DGPAR(ISPGRP,7)
      K1=DGPAR(ISPGRP,8)
      K2=DGPAR(ISPGRP,9)
      K3=DGPAR(ISPGRP,10)
      K4=DGPAR(ISPGRP,11)
      LNDG=B0
     1      +B1*LOG(DBH+K1)
     2      +B2*DBH**K2
     3      +B3*LOG((CR+0.2)/1.2)
     4      +B4*LOG(SITE)
     5      +B5*((SBAL1**K3)/LOG(DBH+K4))
     6      +B6*SQRT(SBA1)
C
C     CROWN RATIO ADJUSTMENT
C
      CRADJ=1.0-EXP(-(25.0*CR)**2)
      IF(ISPGRP .EQ. 1) THEN
         ADJ=1.0
      ELSEIF(ISPGRP .EQ. 2) THEN
         ADJ=0.8722
      ELSEIF(ISPGRP .EQ. 3) THEN
         ADJ=1.0
      ELSEIF(ISPGRP .EQ. 6) THEN
         ADJ=0.7928
      ELSEIF(ISPGRP .EQ. 8) THEN
         ADJ=1.0
      ELSE
         ADJ=0.8
      ENDIF
      DG=EXP(LNDG)*CRADJ*ADJ
      RETURN
      END
*******************************************************************************
      SUBROUTINE DG_RAP(ISPGRP,DBH,CR,SITE,SBAL1,SBA1,DG)
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4 B0,B1,B2,B3,B4,B5,B6,K1,K2,K3,K4,DBH,CR,SBAL1,SBA1,LNDG,
     1       SITE,DG,DGPAR(7,11),CRADJ,ADJ
C
C  DIAMETER GROWTH PARAMETERS (11 parameters - all species)
C
C     RA Coefficients from Hann and Mainwaring (2023) Forest Biometrics Research Paper #6
C
C     The following species were annualized by adding ln(0.2) to the intercept terms
C
C     DF Coefficients from Hann, Marshall, and Hanus (2006) FRL Research Contribution 40
C     WH Coefficients from Unpublished Equation on File at OSU Dept. Forest Resources
C     RC Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #2
C     BL Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     PD Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C     WI Coefficients from Hann and Hanus (2002) FRL Research Contribution 39
C
      DATA DGPAR/
     1          -3.82892681   ,     -6.95196910   ,     -6.48391203   ,! RA,DF,WH
     1         -13.06399888   ,     -5.02393713   ,     -9.69296474   ,! RC,BL,PD
     1          -9.69296474   ,                                        ! WI
C
     2           0.675980965  ,      1.098406840  ,      0.4150723209 ,! RA,DF,WH
     2           0.784133664  ,      1.0          ,      1.0          ,! RC,BL,PD
     2           1.0          ,                                        ! WI
C
     3          -0.146294494  ,     -0.05218621   ,     -0.023744997  ,! RA,DF,WH
     3          -0.0261377888 ,     -0.05         ,     -0.00000035   ,! RC,BL,PD
     3          -0.00000035   ,                                        ! WI
C
     4           1.33546052   ,      1.01380810   ,      0.907837299  ,! RA,DF,WH
     4           0.70174783   ,      0.0          ,      0.31176647   ,! RC,BL,PD
     4           0.31176647   ,                                        ! WI
C
     5           0.828183586  ,      0.91202025   ,      1.1346766989 ,! RA,DF,WH
     5           2.057236260  ,      0.324349277  ,      0.0          ,! RC,BL,PD
     5           0.0          ,                                        ! WI
C
     6          -0.0222607698 ,     -0.01756220   ,     -0.015333503  ,! RA,DF,WH
     6          -0.00415440257,      0.0          ,      0.0          ,! RC,BL,PD
     6           0.0          ,                                        ! WI
C
     7          -0.0351133186 ,     -0.05168923   ,     -0.03309787   ,! RA,DF,WH
     7           0.0          ,     -0.0989519477 ,     -0.0730788052 ,! RC,BL,PD
     7          -0.0730788052 ,                                        ! WI
C
     8           1.0          ,      6.0          ,      5.0          ,! RA,DF,WH
     8           5.0          ,     10.0          ,   4000.0          ,! RC,BL,PD
     8        4000.0          ,                                        ! WI
C
     9           1.0          ,      1.0          ,      1.0          ,! RA,DF,WH
     9           1.0          ,      1.0          ,      4.0          ,! RC,BL,PD
     9           4.0          ,                                        ! BL
C
     X           1.0          ,      1.0          ,      1.0          ,! RA,DF,WH
     X           1.0          ,      1.0          ,      1.0          ,! RC,BL,PD
     X           1.0          ,                                        ! WI
C
     A           2.8          ,      2.7          ,      2.7          ,! RA,DF,WH
     A           2.7          ,      2.7          ,      2.7          ,! RC,BL,PD
     A           2.7/                                                  ! WI
C
      B0=DGPAR(ISPGRP,1)
      B1=DGPAR(ISPGRP,2)
      B2=DGPAR(ISPGRP,3)
      B3=DGPAR(ISPGRP,4)
      B4=DGPAR(ISPGRP,5)
      B5=DGPAR(ISPGRP,6)
      B6=DGPAR(ISPGRP,7)
      K1=DGPAR(ISPGRP,8)
      K2=DGPAR(ISPGRP,9)
      K3=DGPAR(ISPGRP,10)
      K4=DGPAR(ISPGRP,11)
      LNDG=B0
     1      +B1*LOG(DBH+K1)
     2      +B2*DBH**K2
     3      +B3*LOG((CR+0.2)/1.2)
     4      +B4*LOG(SITE)
     5      +B5*((SBAL1**K3)/LOG(DBH+K4))
     6      +B6*SQRT(SBA1)
C
C     CROWN RATIO ADJUSTMENT
C
      CRADJ=1.0-EXP(-(25.0*CR)**2)
      IF(ISPGRP .LE. 3) THEN
         ADJ=1.0
      ELSE
         ADJ=0.8
      ENDIF
      DG=EXP(LNDG)*CRADJ*ADJ
      RETURN
      END
C**********************************************************************
      SUBROUTINE PM_SWO(ISPGRP,DBH,CR,SI_1,BAL,OG,POW,PM)
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4 DBH,CR,SI_1,BAL,OG,POW,PM,B0,B1,B2,B3,B4,B5,B6,B7,
     1       MPAR(18,9)
C
C  NEW SWO MORTALITY WITH REVISED CLO PARAMETERS (8 parameters - all species)
C
C     DF Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     GW Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     PP Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     SP Coefficients from Unpublished Equation on File at OSU Dept. Forest Resources
C     IC Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     WH Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     RC Coefficients from WH of Hann, Marshall, Hanus (2003) FRL Research Contribution 40
C     PY Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     MD Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     GC Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     TA Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     CL Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     BL Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     WO Coefficients from Gould, Marshall, and Harrington (2008) West. J. Appl. For. 23: 26-33
C     BO Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     RA Coefficients from Best Guess
C     PD Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     WI Coefficients from Best Guess
C
      DATA MPAR/
     1         -4.648483270, -2.215777201, -1.050000682, -1.531051304, !  DF,GW,PP,SP
     1         -1.922689902, -1.166211991, -0.761609   , -4.072781265, !  IC,WH,RC,PY
     1         -6.089598985, -4.317549852, -2.410756914, -2.990451960, !  MD,GC,TA,CL
     1         -2.976822456, -6.00031085 , -3.108619921, -2.0        , !  BL,WO,BO,RA
     1         -3.020345211, -1.386294361,                             !  PD,WI
C
     2         -0.266558690, -0.162895666, -0.194363402,  0.0        , !  DF,GW,PP,SP
     2         -0.136081990,  0.0        , -0.529366   , -0.176433475, !  IC,WH,RC,PY
     2         -0.245615070, -0.057696253,  0.0        ,  0.0        , !  MD,GC,TA,CL
     2          0.0        , -0.10490823 , -0.570366764, -0.5        , !  BL,WO,BO,RA
     2          0.0        ,  0.0        ,                             !  PD,WI
C
     3          0.003699110,  0.003317290,  0.003803100,  0.0        , !  DF,GW,PP,SP
     3          0.002479863,  0.0        ,  0.0        ,  0.0        , !  IC,WH,RC,PY
     3          0.0        ,  0.0        ,  0.0        ,  0.0        , !  MD,GC,TA,CL
     3          0.0        ,  0.0        ,  0.018205398,  0.015      , !  BL,WO,BO,RA
     3          0.0        ,  0.0        ,                             !  PD,WI
C
     4         -2.118026640, -3.561438261, -3.557300286,  0.0        , !  DF,GW,PP,SP
     4         -3.178123293, -4.602668157, -4.74019    , -1.729453975, !  IC,WH,RC,PY
     4         -3.208265570,  0.0        , -1.049353753,  0.0        , !  MD,GC,TA,CL
     4         -6.223250962, -0.99541909 , -4.584655216, -3.0        , !  BL,WO,BO,RA
     4         -8.467882343,  0.0        ,                             !  PD,WI
C
     5          0.025499430,  0.014644689,  0.003971638,  0.0        , !  DF,GW,PP,SP
     5          0.0        ,  0.0        ,  0.0119587  ,  0.0        , !  IC,WH,RC,PY
     5          0.033348079,  0.004861355,  0.008845583,  0.0        , !  MD,GC,TA,CL
     5          0.0        ,  0.00912739 ,  0.014926170,  0.015      , !  BL,WO,BO,RA
     5          0.013966388,  0.0        ,                             !  PD,WI
C
     6          0.003361340,  0.0        ,  0.005573601,  0.0        , !  DF,GW,PP,SP
     6          0.004684133,  0.0        ,  0.00756365 ,  0.012525642, !  IC,WH,RC,PY
     6          0.013571319,  0.00998129 ,  0.0        ,  0.002884840, !  MD,GC,TA,CL
     6          0.0        ,  0.87115652 ,  0.012419026,  0.01       , !  BL,WO,BO,RA
     6          0.009461545,  0.0        ,                             !  PD,WI
C
     7          0.013553950,  0.0        ,  0.0        ,  0.0        , !  DF,GW,PP,SP
     7          0.0        ,  0.0        ,  0.0        ,  0.0        , !  IC,WH,RC,PY
     7          0.0        ,  0.0        ,  0.0        ,  0.0        , !  MD,GC,TA,CL
     7          0.0        ,  0.0        ,  0.0        ,  0.0        , !  BL,WO,BO,RA
     7          0.0        ,  0.0        ,                             !  PD,WI
C
     8         -2.723470950,  0.0        ,  0.0        ,  0.0        , !  DF,GW,PP,SP
     8          0.0        ,  0.0        ,  0.0        ,  0.0        , !  IC,WH,RC,PY
     8          0.0        ,  0.0        ,  0.0        ,  0.0        , !  MD,GC,TA,CL
     8          0.0        ,  0.0        ,  0.0        ,  0.0        , !  BL,WO,BO,RA
     8          0.0        ,  0.0        ,                             !  PD,WI
C
     9          1.0        ,  1.0        ,  1.0        ,  1.0        , !  DF,GW,PP,SP
     9          1.0        ,  1.0        ,  1.0        ,  1.0        , !  IC,WH,RC,PY
     9          1.0        ,  1.0        ,  1.0        ,  1.0        , !  MD,GC,TA,CL
     9          1.0        ,  1.0        ,  1.0        ,  1.0        , !  BL,WO,BO,RA
     9          1.0        ,  1.0/                                     !  PD,WI
C
      B0=MPAR(ISPGRP,1)
      B1=MPAR(ISPGRP,2)
      B2=MPAR(ISPGRP,3)
      B3=MPAR(ISPGRP,4)
      B4=MPAR(ISPGRP,5)
      B5=MPAR(ISPGRP,6)
      B6=MPAR(ISPGRP,7)
      B7=MPAR(ISPGRP,8)
      POW=MPAR(ISPGRP,9)
      IF(ISPGRP .EQ. 14) THEN   ! Oregon White Oak
         PM=B0+B1*DBH+B2*DBH**2+B3*CR+B4*(SI_1+4.5)+B5*ALOG(BAL+5.0)
      ELSE
         PM=B0+B1*DBH+B2*DBH**2+B3*CR+B4*(SI_1+4.5)+B5*BAL
     1     +B6*BAL*EXP(B7*OG)
      ENDIF
      RETURN
      END
C**********************************************************************
      SUBROUTINE PM_NWO(ISPGRP,DBH,CR,SI_1,SI_2,BAL,POW,PM)
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4 DBH,CR,SI_1,SI_2,BAL,POW,PM,B0,B1,B2,B3,B4,B5,MPAR(11,7),
     1       SQDBH,CR25
C
C  NWO MORTALITY (6 parameters - all species)
C
C     DF Coefficients from Unpublished Equation on File at OSU Dept. Forest Resources
C     GF Coefficients from Unpublished Equation on File at OSU Dept. Forest Resources
C     WH Coefficients from Hann, Marshall, Hanus (2003) FRL Research Contribution 40
C     RC Coefficients from WH of Hann, Marshall, Hanus (2003) FRL Research Contribution 40
C     PY Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     MD Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     BL Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     WO Coefficients from Gould, Marshall, and Harrington (2008) West. J. Appl. For. 23: 26-33
C     RA Coefficients from Best Guess
C     PD Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     WI Coefficients from Best Guess
C
      DATA MPAR/
     1         -4.13142    , -7.60159    , -0.761609   , -0.761609   , !  DF,GF,WH,RC
     1         -4.072781265, -6.089598985, -2.976822456, -6.00031085 , !  PY,MD,BL,WO
     1         -2.0        , -3.020345211, -1.386294361,               !  RA,PD,WI
C
     2         -1.13736    , -0.200523   , -0.529366   , -0.529366   , !  DF,GF,WH,RC
     2         -0.176433475, -0.245615070,  0.0        , -0.10490823 , !  PY,MD,BL,WO
     2         -0.5        ,  0.0        ,  0.0        ,               !  RA,PD,WI
C
     3          0.0        ,  0.0        ,  0.0        ,  0.0        , !  DF,GF,WH,RC
     3          0.0        ,  0.0        ,  0.0        ,  0.0        , !  PY,MD,BL,WO
     3          0.015      ,  0.0        ,  0.0        ,               !  RA,PD,WI
C
     4         -0.823305   ,  0.0        , -4.74019    , -4.74019    , !  DF,GF,WH,RC
     4         -1.729453975, -3.208265570, -6.223250962, -0.99541909 , !  PY,MD,BL,WO
     4         -3.0        , -8.467882343,  0.0        ,               !  RA,PD,WI
C
     5          0.0307749  ,  0.0441333  ,  0.0119587  ,  0.0119587  , !  DF,GF,WH,RC
     5          0.0        ,  0.033348079,  0.0        ,  0.00912739 , !  PY,MD,BL,WO
     5          0.015      ,  0.013966388,  0.0        ,               !  RA,PD,WI
C
     6          0.00991005 ,  0.00063849 ,  0.00756365 ,  0.00756365 , !  DF,GF,WH,RC
     6          0.012525642,  0.013571319,  0.0        ,  0.87115652 , !  PY,MD,BL,WO
     6          0.01       ,  0.009461545,  0.0        ,               !  RA,PD,WI
C
     7          1.0        ,  1.0        ,  1.0        ,  1.0        , !  DF,GF,WH,RC
     7          1.0        ,  1.0        ,  1.0        ,  1.0        , !  PY,MD,BL,WO
     7          1.0        ,  1.0        ,  1.0/                       !  RA,PD,WI
C
      B0=MPAR(ISPGRP,1)
      B1=MPAR(ISPGRP,2)
      B2=MPAR(ISPGRP,3)
      B3=MPAR(ISPGRP,4)
      B4=MPAR(ISPGRP,5)
      B5=MPAR(ISPGRP,6)
      POW=MPAR(ISPGRP,7)
      SQDBH=DBH**0.5
      CR25=CR**0.25
      IF(ISPGRP .EQ. 1)THEN                          ! Douglas fir
         PM=B0+B1*SQDBH+B3*CR25+B4*(SI_1+4.5)+B5*BAL
      ELSE IF(ISPGRP .EQ. 2)THEN                     ! Grand Fir
         PM=B0+B1*DBH+B4*(SI_1+4.5)+B5*(BAL/DBH)
      ELSEIF(ISPGRP .EQ. 3 .OR. ISPGRP .EQ. 4) THEN  ! Western Hemlock and Western Red Cedar
         PM=B0+B1*DBH+B2*DBH**2+B3*CR+B4*(SI_2+4.5)+B5*BAL
      ELSEIF(ISPGRP .EQ. 8) THEN   ! Oregon White Oak
         PM=B0+B1*DBH+B2*DBH**2+B3*CR+B4*(SI_1+4.5)+B5*ALOG(BAL+5.0)
      ELSE
         PM=B0+B1*DBH+B2*DBH**2+B3*CR+B4*(SI_1+4.5)+B5*BAL
      ENDIF
      RETURN
      END
C**********************************************************************
      SUBROUTINE PM_SMC(ISPGRP,DBH,CR,SI_1,SI_2,BAL,POW,PM)
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4 DBH,CR,SI_1,SI_2,BAL,POW,PM,B0,B1,B2,B3,B4,B5,MPAR(11,7)
C
C  SMC MORTALITY (6 parameters - all species)
C
C     DF Coefficients from Hann, Marshall, and Hanus (2006) FRL Research Contribution 49
C     GF Coefficients from Unpublished Equation on File at OSU Dept. Forest Resources
C     WH Coefficients from Hann, Marshall, Hanus (2003) FRL Research Contribution 40
C     RC Coefficients from WH of Hann, Marshall, Hanus (2003) FRL Research Contribution 40
C     PY Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     MD Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     BL Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     WO Coefficients from Gould, Marshall, and Harrington (2008) West. J. Appl. For. 23: 26-33
C     RA Coefficients from Best Guess
C     PD Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     WI Coefficients from Best Guess
C
      DATA MPAR/
     1         -3.12161659 , -7.60159    , -0.761609   , -0.761609   , !  DF,GF,WH,RC
     1         -4.072781265, -6.089598985, -2.976822456, -6.00031085 , !  PY,MD,BL,WO
     1         -2.0        , -3.020345211, -1.386294361,               !  RA,PD,WI
C
     2         -0.44724396 , -0.200523   , -0.529366   , -0.529366   , !  DF,GF,WH,RC
     2         -0.176433475, -0.245615070,  0.0        , -0.10490823 , !  PY,MD,BL,WO
     2         -0.5        ,  0.0        ,  0.0        ,               !  RA,PD,WI
C
     3          0.0        ,  0.0        ,  0.0        ,  0.0        , !  DF,GF,WH,RC
     3          0.0        ,  0.0        ,  0.0        ,  0.0        , !  PY,MD,BL,WO
     3          0.015      ,  0.0        ,  0.0        ,               !  RA,PD,WI
C
     4         -2.48387172 ,  0.0        , -4.74019    , -4.74019    , !  DF,GF,WH,RC
     4         -1.729453975, -3.208265570, -6.223250962, -0.99541909 , !  PY,MD,BL,WO
     4         -3.0        , -8.467882343,  0.0        ,               !  RA,PD,WI
C
     5          0.01843137 ,  0.0441333  ,  0.0119587  ,  0.0119587  , !  DF,GF,WH,RC
     5          0.0        ,  0.033348079,  0.0        ,  0.00912739 , !  PY,MD,BL,WO
     5          0.015      ,  0.013966388,  0.0        ,               !  RA,PD,WI
C
     6          0.01353918 ,  0.00063849 ,  0.00756365 ,  0.00756365 , !  DF,GF,WH,RC
     6          0.012525642,  0.013571319,  0.0        ,  0.87115652 , !  PY,MD,BL,WO
     6          0.01       ,  0.009461545,  0.0        ,               !  RA,PD,WI
C
     7          1.0        ,  1.0        ,  1.0        ,  1.0        , !  DF,GF,WH,RC
     7          1.0        ,  1.0        ,  1.0        ,  1.0        , !  PY,MD,BL,WO
     7          1.0        ,  1.0        ,  1.0/                       !  RA,PD,WI
C
      B0=MPAR(ISPGRP,1)
      B1=MPAR(ISPGRP,2)
      B2=MPAR(ISPGRP,3)
      B3=MPAR(ISPGRP,4)
      B4=MPAR(ISPGRP,5)
      B5=MPAR(ISPGRP,6)
      POW=MPAR(ISPGRP,7)
      IF(ISPGRP .EQ. 2) THEN                          ! Grand Fir
         PM=B0+B1*DBH+B4*(SI_1+4.5)+B5*(BAL/DBH)
      ELSEIF(ISPGRP .EQ. 3 .OR. ISPGRP .EQ. 4) THEN   ! Western Hemlock and Western Red Cedar
         PM=B0+B1*DBH+B2*DBH**2+B3*CR+B4*(SI_2+4.5)+B5*BAL
      ELSEIF(ISPGRP .EQ. 8) THEN   ! Oregon White Oak
         PM=B0+B1*DBH+B2*DBH**2+B3*CR+B4*(SI_1+4.5)+B5*ALOG(BAL+5.0)
      ELSE
         PM=B0+B1*DBH+B2*DBH**2+B3*CR+B4*(SI_1+4.5)+B5*BAL
      ENDIF
      RETURN
      END
C**********************************************************************
      SUBROUTINE PM_RAP(ISPGRP,DBH,CR,SI_1,SI_2,BAL,BA,POW,PM)
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4 DBH,CR,SI_1,SI_2,BAL,BA,POW,PM,B0,B1,B2,B3,B4,B5,
     1       MPAR(7,6),SITE
C
C  RAP MORTALITY (6 parameters - all species)
C
C     RA Coefficients from Hann and Mainwaring Forest Biometrics Research Paper #6
C     DF Coefficients from Hann, Marshall, and Hanus (2006) FRL Research Contribution 49
C     WH Coefficients from Hann, Marshall, Hanus (2003) FRL Research Contribution 40
C     RC Coefficients from WH of Hann, Marshall, Hanus (2003) FRL Research Contribution 40
C     BL Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     PD Coefficients from Hann and Hanus (2001) FRL Research Contribution 34
C     WI Coefficients from Best Guess
C
      DATA MPAR/
     1         -4.409350098 , -3.12161659 , -0.761609   , -0.761609  , !  RA,DF,WH,RC
     1         -2.976822456 , -3.020345211, -1.386294361,              !  BL,PD,WI
C
     2         -0.840245936 , -0.44724396 , -0.529366   , -0.529366  , !  RA,DF,WH,RC
     2          0.0         ,  0.0        ,  0.0        ,              !  BL,PD,WI,WO
C
     3          0.0         , -2.48387172 , -4.74019    , -4.74019   , !  RA,DF,WH,RC
     3         -6.223250962 , -8.467882343,  0.0        ,              !  BL,PD,WI
C
     4          0.012283316 ,  0.01843137 ,  0.0119587  ,  0.0119587 , !  RA,DF,WH,RC
     4          0.0         ,  0.013966388,  0.0        ,              !  BL,PD,WI
C
     5          0.031423765 ,  0.01353918 ,  0.00756365 ,  0.00756365, !  RA,DF,WH,RC
     5          0.0         ,  0.009461545,  0.0        ,              !  BL,PD,WI
C
     6          0.016120038 ,  0.0        ,  0.0        ,  0.0       , !  RA,DF,WH,RC
     6          0.0         ,  0.0        ,  0.0/                      !  BL,PD,WI

C
      B0=MPAR(ISPGRP,1)
      B1=MPAR(ISPGRP,2)
      B2=MPAR(ISPGRP,3)
      B3=MPAR(ISPGRP,4)
      B4=MPAR(ISPGRP,5)
      B5=MPAR(ISPGRP,6)
      POW=0.2
      IF(ISPGRP .EQ. 1) THEN
         POW=1.0
      ENDIF
      IF(ISPGRP .EQ. 1) THEN
         SITE=SI_1+4.5
      ELSEIF(ISPGRP .EQ. 2 .OR. ISPGRP .GT. 4)THEN
         SITE=SI_2+4.5
      ELSEIF(ISPGRP .EQ. 3 .OR. ISPGRP .EQ. 4)THEN
         SITE=-0.432 + 0.899 * (SI_2+4.5)
      ENDIF
      PM=B0+B1*DBH+B2*CR+B3*SITE+B4*BAL+B5*BA
      RETURN
      END
**********************************************************************
      SUBROUTINE HD_NWO(ISPGRP,DBH,PRDHT)
      IMPLICIT NONE
      REAL*4 DBH,PRDHT,HDPAR(11,3),B0,B1,B2
      INTEGER*4 ISPGRP
C
C  HEIGHT/DIAMETER PARAMETERS (3 parameters - all species)
C
C     DF Coefficients from Wang and Hann (1988) FRL Research Paper 51
C     GF Coefficients from Wang and Hann (1988) FRL Research Paper 51
C     WH Coefficients from Johnson (2000) Willamette Industries Report
C     RC Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #2
C     PY Coefficients from Wang and Hann (1988) FRL Research Paper 51
C     MD Coefficients from Wang and Hann (1988) FRL Research Paper 51
C     BL Coefficients from Wang and Hann (1988) FRL Research Paper 51
C     WO Coefficients from Gould, Marshall, and Harrington (2008) West. J. Appl. For. 23: 26-33
C     RA Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #1
C     PD Coefficients from Wang and Hann (1988) FRL Research Paper 51
C     WI Coefficients from Wang and Hann (1988) FRL Research Paper 51
C
      DATA HDPAR/
     1            7.04524    ,  7.42808    ,  5.93792    ,  6.14817441,!  DF,GF,WH,RC
     1            9.30172    ,  5.84487    ,  5.21462    ,  4.69753118,!  PY,MD,BL,WO
     1            5.59759126 ,  4.49727    ,  4.88361    ,             !  RA,PD,WI
C
     2           -5.16836    , -5.80832    , -4.43822    , -5.40092761,!  DF,GF,WH,RC
     2           -7.50951    , -3.84795    , -2.70252    , -3.51586969,!  PY,MD,BL,WO
     2           -3.19942952 , -2.07667    , -2.47605    ,             !  RA,PD,WI
C
     3           -0.253869   ,  -0.240317  , -0.411373   , -0.38922036,!  DF,GF,WH,RC
     3           -0.100000   ,  -0.289213  , -0.354756   , -0.57665068,!  PY,MD,BL,WO
     3           -0.38783403 ,  -0.388650  , -0.309050  /              !  RA,PD,WI
C
      B0=HDPAR(ISPGRP,1)
      B1=HDPAR(ISPGRP,2)
      B2=HDPAR(ISPGRP,3)
      PRDHT=4.5+EXP(B0+B1*DBH**B2)
      RETURN
      END

**********************************************************************
      SUBROUTINE HD_SMC(ISPGRP,DBH,PRDHT)
      IMPLICIT NONE
      REAL*4 DBH,PRDHT,HDPAR(11,3),B0,B1,B2,X
      INTEGER*4 ISPGRP
C
C  HEIGHT/DIAMETER PARAMETERS (3 parameters - all species)
C
C     DF Coefficients from Hanus, Marshall, and Hann (1999) FRL Research Contribution 25
C     GF Coefficients from Wang and Hann (1988) FRL Research Paper 51
C     WH Coefficients from Hanus, Marshall, and Hann (1999) FRL Research Contribution 25
C     RC Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #2
C     PY Coefficients from Wang and Hann (1988) FRL Research Paper 51
C     MD Coefficients from Wang and Hann (1988) FRL Research Paper 51
C     BL Coefficients from Wang and Hann (1988) FRL Research Paper 51
C     WO Coefficients from Gould, Marshall, and Harrington (2008) West. J. Appl. For. 23: 26-33
C     RA Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #1
C     PD Coefficients from Wang and Hann (1988) FRL Research Paper 51
C     WI Coefficients from Wang and Hann (1988) FRL Research Paper 51
C
      DATA HDPAR/
     1            7.262195456,  7.42808    ,  6.555344622,  6.14817441,!  DF,GF,WH,RC
     1            9.30172    ,  5.84487    ,  5.21462    ,  4.69753118,!  PY,MD,BL,WO
     1            5.59759126 ,  4.49727    ,  4.88361    ,             !  RA,PD,WI
C
     2           -5.899759104, -5.80832    , -5.137174162, -5.40092761,!  DF,GF,WH,RC
     2           -7.50951    , -3.84795    , -2.70252    , -3.51586969,!  PY,MD,BL,WO
     2           -3.19942952 , -2.07667    , -2.47605    ,             !  RA,PD,WI
C
     3           -0.287207389, -0.240317   , -0.364550800, -0.38922036,!  DF,GF,WH,RC
     3           -0.100000   ,  -0.289213  , -0.354756   , -0.57665068,!  PY,MD,BL,WO
     3           -0.38783403 ,  -0.388650  , -0.309050  /              !  RA,PD,WI
C
      B0=HDPAR(ISPGRP,1)
      B1=HDPAR(ISPGRP,2)
      B2=HDPAR(ISPGRP,3)
      PRDHT=4.5+EXP(B0+B1*DBH**B2)
      RETURN
      END

C**********************************************************************
      SUBROUTINE HCB_NWO(ISPGRP,HT,DBH,CCFL,BA,SI_1,SI_2,OG,HCB)
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4 HT,DBH,CCFL,BA,SI_1,SI_2,OG,HCB,HCBPAR(11,7),B0,B1,B2,B3,
     1       B4,B5,B6
C
C  HEIGHT TO CROWN BASE (7 parameters - all species)
C
C     DF Coefficients from Zumrawi and Hann (1989) FRL Research Paper 52
C     GF Coefficients from Zumrawi and Hann (1989) FRL Research Paper 52
C     WH Coefficients from Johnson (2002) Willamette Industries Report
C     RC Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #2
C     PY Coefficients from Hanus, Hann, and Marshall (2000) FRL Research Contribution 29
C     MD Coefficients from Hanus, Hann, and Marshall (2000) FRL Research Contribution 29
C     BL Coefficients from Hanus, Hann, and Marshall (2000) FRL Research Contribution 29
C     WO Coefficients from Gould, Marshall, and Harrington (2008) West. J. Appl. For. 23: 26-33
C     RA Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #1
C     PD Coefficients from Hanus, Hann, and Marshall (2000) FRL Research Contribution 29
C     WI Coefficients from Hanus, Hann, and Marshall (2000) FRL Research Contribution 29
C
      DATA HCBPAR/
     1        1.94093    ,  1.04746    ,  1.92682    ,  4.49102006 ,   !  DF,GF,WH,RC
     1        0.0        ,  2.955339267,  0.9411395642, 1.05786632 ,   !  PY,MD,BL,WO
     1        0.56713781 ,  0.0        ,  0.0        ,                 !  RA,PD,WI
C
     2       -0.0065029  , -0.0066643  , -0.00280478 ,  0.0        ,   !  DF,GF,WH,RC
     2        0.0        ,  0.0        , -0.00768402 ,  0.0        ,   !  PY,MD,BL,WO
     2       -0.010377976,  0.0        ,  0.0        ,                 !  RA,PD,WI
C
     3       -0.0048737  , -0.0067129  , -0.0011939  , -0.00132412 ,   !  DF,GF,WH,RC
     3        0.0        ,  0.0        , -0.005476131, -0.00183283 ,   !  PY,MD,BL,WO
     3       -0.002066036, -0.005666559, -0.005666559,                 !  RA,PD,WI
C
     4       -0.261573   ,  0.0        , -0.513134   , -1.01460531 ,   !  DF,GF,WH,RC
     4        0.0        , -0.798610738,  0.0        , -0.28644547 ,   !  PY,MD,BL,WO
     4        0.0        , -0.745540494, -0.745540494,                 !  RA,PD,WI
C
     5        1.08785    ,  0.0        ,  3.68901    ,  0.0        ,   !  DF,GF,WH,RC
     5        2.030940382,  3.095269471,  0.0        ,  0.0        ,   !  PY,MD,BL,WO
     5        1.39796223 ,  0.0        ,  0.0        ,                 !  RA,PD,WI
C
     6        0.0        ,  0.0        ,  0.00742219 ,  0.01340624 ,   !  DF,GF,WH,RC
     6        0.0        ,  0.0        ,  0.0        ,  0.0        ,   !  PY,MD,BL,WO
     6        0.0        ,  0.038476613,  0.038476613,                 !  RA,PD,WI
C
     7        0.0        ,  0.0        ,  0.0        ,  0.0        ,   !  DF,GF,WH,RC
     7        0.0        ,  0.700465646,  0.0        ,  0.0        ,   !  PY,MD,BL,WO
     7        0.0        ,  0.0        ,  0.0/                         !  RA,PD,WI
C
      B0=HCBPAR(ISPGRP,1)
      B1=HCBPAR(ISPGRP,2)
      B2=HCBPAR(ISPGRP,3)
      B3=HCBPAR(ISPGRP,4)
      B4=HCBPAR(ISPGRP,5)
      B5=HCBPAR(ISPGRP,6)
      B6=HCBPAR(ISPGRP,7)
      IF(ISPGRP .EQ. 3) THEN
         HCB=HT/(1.0+EXP(B0+B1*HT+B2*CCFL+B3*ALOG(BA)+B4*(DBH/HT)
     1      +B5*SI_2+B6*OG**2))
      ELSE
         HCB=HT/(1.0+EXP(B0+B1*HT+B2*CCFL+B3*ALOG(BA)+B4*(DBH/HT)
     1      +B5*SI_1+B6*OG**2))
      ENDIF
      RETURN
      END

C**********************************************************************
      SUBROUTINE HCB_SMC(ISPGRP,HT,DBH,CCFL,BA,SI_1,SI_2,OG,HCB)
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4 HT,DBH,CCFL,BA,SI_1,SI_2,OG,HCB,HCBPAR(11,7),B0,B1,B2,B3,
     1       B4,B5,B6
C
C  HEIGHT TO CROWN BASE (7 parameters - all species)
C
C     DF Coefficients from Zumrawi and Hann (1989) FRL Research Paper 52
C     GF Coefficients from Zumrawi and Hann (1989) FRL Research Paper 52
C     WH Coefficients from Hann, Marshall, and Hanus FRL Research Contribution 40
C     RC Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #2
C     PY Coefficients from Hanus, Hann, and Marshall (2000) FRL Research Contribution 29
C     MD Coefficients from Hanus, Hann, and Marshall (2000) FRL Research Contribution 29
C     BL Coefficients from Hanus, Hann, and Marshall (2000) FRL Research Contribution 29
C     WO Coefficients from Gould, Marshall, and Harrington (2008) West. J. Appl. For. 23: 26-33
C     RA Coefficients from Hann and Hanus (2002) OSU Department of Forest Management Internal Report #1
C     PD Coefficients from Hanus, Hann, and Marshall (2000) FRL Research Contribution 29
C     WI Coefficients from Hanus, Hann, and Marshall (2000) FRL Research Contribution 29
C
      DATA HCBPAR/
     1        1.94093    ,  1.04746    ,  8.856979690,  4.49102006 ,   !  DF,GF,WH,RC
     1        0.0        ,  2.955339267,  0.9411395642, 1.05786632 ,   !  PY,MD,BL,WO
     1        0.56713781 ,  0.0        ,  0.0        ,                 !  RA,PD,WI
C
     2       -0.0065029  , -0.0066643  , -0.004799358,  0.0        ,   !  DF,GF,WH,RC
     2        0.0        ,  0.0        , -0.00768402 ,  0.0        ,   !  PY,MD,BL,WO
     2       -0.010377976,  0.0        ,  0.0        ,                 !  RA,PD,WI
C
     3       -0.0048737  , -0.0067129  , -0.000842256, -0.00132412 ,   !  DF,GF,WH,RC
     3        0.0        ,  0.0        , -0.005476131, -0.00183283 ,   !  PY,MD,BL,WO
     3       -0.002066036, -0.005666559, -0.005666559,                 !  RA,PD,WI
C
     4       -0.261573   ,  0.0        , -1.661329351, -1.01460531 ,   !  DF,GF,WH,RC
     4        0.0        , -0.798610738,  0.0        , -0.28644547 ,   !  PY,MD,BL,WO
     4        0.0        , -0.745540494, -0.745540494,                 !  RA,PD,WI
C
     5        1.08785    ,  0.0        ,  5.485552579,  0.0        ,   !  DF,GF,WH,RC
     5        2.030940382,  3.095269471,  0.0        ,  0.0        ,   !  PY,MD,BL,WO
     5        1.39796223 ,  0.0        ,  0.0        ,                 !  RA,PD,WI
C
     6        0.0        ,  0.0        ,  0.0        ,  0.01340624 ,   !  DF,GF,WH,RC
     6        0.0        ,  0.0        ,  0.0        ,  0.0        ,   !  PY,MD,BL,WO
     6        0.0        ,  0.038476613,  0.038476613,                 !  RA,PD,WI
C
     7        0.0        ,  0.0        ,  0.0        ,  0.0        ,   !  DF,GF,WH,RC
     7        0.0        ,  0.700465646,  0.0        ,  0.0        ,   !  PY,MD,BL,WO
     7        0.0        ,  0.0        ,  0.0/                         !  RA,PD,WI
C
      B0=HCBPAR(ISPGRP,1)
      B1=HCBPAR(ISPGRP,2)
      B2=HCBPAR(ISPGRP,3)
      B3=HCBPAR(ISPGRP,4)
      B4=HCBPAR(ISPGRP,5)
      B5=HCBPAR(ISPGRP,6)
      B6=HCBPAR(ISPGRP,7)
      HCB=HT/(1.0+EXP(B0+B1*HT+B2*CCFL+B3*ALOG(BA)+B4*(DBH/HT)
     1   +B5*SI_1+B6*OG**2))
      RETURN
      END
C**********************************************************************
      SUBROUTINE MCW_SWO(ISPGRP,D,H,MCW)
C     DETERMINE MCW FOR EACH TREE
C**********************************************************************
C
C     MCW = MCW VALUE
C
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4    D,H,MCW,MCWPAR(18,4),B0,B1,B2,DBH,HT,PKDBH
C
C  MAXIMUM CROWN WIDTH (4 parameters - all species)
C
C     DF Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     GW Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     PP Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     SP Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     IC Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     WH Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     RC Coefficients from Smith (1966) Proc. 6th World Forestry Conference
C     PY Coefficients from WH
C     MD Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     GC Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     TA Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     CL Coefficients from TA
C     BL Coefficients from Ek (1974) School of Natural Res., U. Wisc., Forestry Res. Notes.
C     WO Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     BO Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     RA Coefficients from Smith (1966) Proc. 6th World Forestry Conference
C     PD Coefficients from GC
C     WI Coefficients from GC
C
      DATA MCWPAR/
     1            4.6366    ,   6.1880    ,   3.4835    ,   4.6600546 ,! DF,GW,PP,SP
     1            3.2837    ,   4.5652    ,   4.0       ,   4.5652    ,! IC,WH,RC,PY
     1            3.4298629 ,   2.9793895 ,   4.4443    ,   4.4443    ,! MD,GC,TA,CL
     1            4.0953    ,   3.0785639 ,   3.3625    ,   8.0       ,! BL,WO,BO,RA
     1            2.9793895 ,   2.9793895 ,                            !  PD,WI
C
     2            1.6078    ,   1.0069    ,   1.343     ,   1.0701859 ,! DF,GW,PP,SP
     2            1.2031    ,   1.4147    ,   1.65      ,   1.4147    ,! IC,WH,RC,PY
     2            1.3532302 ,   1.5512443 ,   1.7040    ,   1.7040    ,! MD,GC,TA,CL
     2            2.3849    ,   1.9242211 ,   2.0303    ,   1.53      ,! BL,WO,BO,RA
     2            1.5512443 ,   1.5512443 ,                            !  PD,WI
C
     3           -0.009625  ,   0.0       ,  -0.0082544 ,   0.0       ,! DF,GW,PP,SP
     3           -0.0071858 ,   0.0       ,   0.0       ,   0.0       ,! IC,WH,RC,PY
     3            0.0       ,  -0.01416129,  0.0        ,   0.0       ,! MD,GC,TA,CL
     3           -0.011630  ,   0.0       ,  -0.0073307 ,   0.0       ,! BL,WO,BO,RA
     3           -0.01416129,  -0.01416129,                            !  PD,WI
C
     4           88.52      , 999.99      ,  81.35      , 999.99      ,! DF,GW,PP,SP
     4           83.71      , 999.99      , 999.99      , 999.99      ,! IC,WH,RC,PY
     4          999.99      ,  54.77      , 999.99      , 999.99      ,! MD,GC,TA,CL
     4          102.53      , 999.99      , 138.93      , 999.99      ,! BL,WO,BO,RA
     4           54.77      ,  54.77/                                  !  PD,WI
C
      DBH=D
      HT=H
      B0=MCWPAR(ISPGRP,1)
      B1=MCWPAR(ISPGRP,2)
      B2=MCWPAR(ISPGRP,3)
      PKDBH=MCWPAR(ISPGRP,4)
      IF(DBH .GT. PKDBH) THEN
         DBH=PKDBH
      ENDIF
      IF(HT .LT. 4.501)THEN
           MCW=HT/4.5*B0
      ELSE
           MCW=B0+B1*DBH+B2*DBH**2
      ENDIF
      RETURN
      END
C
C**********************************************************************
      SUBROUTINE MCW_NWO(ISPGRP,D,H,MCW)
C     DETERMINE MCW FOR EACH TREE
C**********************************************************************
C
C     MCW = MCW VALUE
C
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4    D,H,MCW,MCWPAR(11,4),B0,B1,B2,DBH,HT,PKDBH
C
C  MAXIMUM CROWN WIDTH (4 parameters - all species)
C
C     DF Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     GF Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     WH Coefficients from Johnson (2002) Willamette Industries Report
C     RC Coefficients from Smith (1966) Proc. 6th World Forestry Conference
C     PY Coefficients from WH of Paine and Hann (1982) FRL Research Paper 46
C     MD Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     BL Coefficients from Ek (1974) School of Natural Res., U. Wisc., Forestry Res. Notes.
C     WO Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     RA Coefficients from Smith (1966) Proc. 6th World Forestry Conference
C     PD Coefficients from GC of Paine and Hann (1982) FRL Research Paper 46
C     WI Coefficients from GC of Paine and Hann (1982) FRL Research Paper 46
C
      DATA MCWPAR/
     1            4.6198    ,   6.1880    ,   4.3586    ,   4.0       ,! DF,GF,WH,RC
     1            4.5652    ,   3.4298629 ,   4.0953    ,   3.0785639 ,! PY,MD,BL,WO
     1            8.0       ,   2.9793895 ,   2.9793895 ,              !  RA,PD,WI
C
     2            1.8426    ,   1.0069    ,   1.57458   ,   1.65      ,! DF,GF,WH,RC
     2            1.4147    ,   1.3532302 ,   2.3849    ,   1.9242211 ,! PY,MD,BL,WO
     2            1.53      ,   1.5512443 ,   1.5512443 ,              !  RA,PD,WI
C
     3           -0.011311  ,   0.0       ,   0.0       ,   0.0       ,! DF,GF,WH,RC
     3            0.0       ,   0.0       ,  -0.0102651 ,   0.0       ,! PY,MD,BL,WO
     3            0.0       ,  -0.01416129,  -0.01416129,              !  RA,PD,WI
C
     4           81.45      , 999.99      ,  76.70      , 999.99      ,! DF,GF,WH,RC
     4          999.99      , 999.99      , 102.53      , 999.99      ,! PY,MD,BL,WO
     4          999.99      ,  54.77      ,  54.77/                    !  RA,PD,WI
C
      DBH=D
      HT=H
      B0=MCWPAR(ISPGRP,1)
      B1=MCWPAR(ISPGRP,2)
      B2=MCWPAR(ISPGRP,3)
      PKDBH=MCWPAR(ISPGRP,4)
      IF(DBH .GT. PKDBH) THEN
         DBH=PKDBH
      ENDIF
      IF(HT .LT. 4.501)THEN
           MCW=HT/4.5*B0
      ELSE
           MCW=B0+B1*DBH+B2*DBH**2
      ENDIF
      RETURN
      END
C
C**********************************************************************
      SUBROUTINE MCW_SMC(ISPGRP,D,H,MCW)
C     DETERMINE MCW FOR EACH TREE
C**********************************************************************
C
C     MCW = MCW VALUE
C
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4    D,H,MCW,MCWPAR(11,4),B0,B1,B2,DBH,HT,PKDBH
C
C  MAXIMUM CROWN WIDTH (4 parameters - all species)
C
C     DF Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     GF Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     WH Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     RC Coefficients from Smith (1966) Proc. 6th World Forestry Conference
C     PY Coefficients from WH of Paine and Hann (1982) FRL Research Paper 46
C     MD Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     BL Coefficients from Ek (1974) School of Natural Res., U. Wisc., Forestry Res. Notes.
C     WO Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     RA Coefficients from Smith (1966) Proc. 6th World Forestry Conference
C     PD Coefficients from GC of Paine and Hann (1982) FRL Research Paper 46
C     WI Coefficients from GC of Paine and Hann (1982) FRL Research Paper 46
C
      DATA MCWPAR/
     1            4.6198    ,   6.1880    ,   4.5652    ,   4.0       ,! DF,GF,WH,RC
     1            4.5652    ,   3.4298629 ,   4.0953    ,   3.0785639 ,! PY,MD,BL,WO
     1            8.0       ,   2.9793895 ,   2.9793895 ,              ! RA,PD,WI
C
     2            1.8426    ,   1.0069    ,   1.4147    ,   1.65      ,! DF,GF,WH,RC
     2            1.4147    ,   1.3532302 ,   2.3849    ,   1.9242211 ,! PY,MD,BL,WO
     2            1.53      ,   1.5512443 ,   1.5512443 ,              ! RA,PD,WI
C
     3           -0.011311  ,   0.0       ,   0.0       ,   0.0       ,! DF,GF,WH,RC
     3            0.0       ,   0.0       ,  -0.011630  ,   0.0       ,! PY,MD,BL,WO
     3            0.0       ,  -0.01416129,  -0.01416129,              ! RA,PD,WI
C
     4           81.45      , 999.99      , 999.99      , 999.99      ,! DF,GF,WH,RC
     4          999.99      , 999.99      , 102.53      , 999.99      ,! PY,MD,BL,WO
     4          999.99      ,  54.77      ,  54.77/                    ! RA,PD,WI
C
      DBH=D
      HT=H
      B0=MCWPAR(ISPGRP,1)
      B1=MCWPAR(ISPGRP,2)
      B2=MCWPAR(ISPGRP,3)
      PKDBH=MCWPAR(ISPGRP,4)
      IF(DBH .GT. PKDBH) THEN
         DBH=PKDBH
      ENDIF
      IF(HT .LT. 4.501)THEN
           MCW=HT/4.5*B0
      ELSE
           MCW=B0+B1*DBH+B2*DBH**2
      ENDIF
      RETURN
      END
C
C**********************************************************************
      SUBROUTINE MCW_RAP(ISPGRP,D,H,MCW)
C     DETERMINE MCW FOR EACH TREE
C**********************************************************************
C
C     MCW = MCW VALUE
C
      IMPLICIT NONE
      INTEGER*4 ISPGRP
      REAL*4    D,H,MCW,MCWPAR(7,5),B0,B1,B2,K,DBH,HT,PKDBH
C
C  MAXIMUM CROWN WIDTH (4 parameters - all species)
C
C     RA Coefficients from Hann, Bluhm, and Hibbs Red Alder Plantation Analysis
C     DF Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     WH Coefficients from Paine and Hann (1982) FRL Research Paper 46
C     RC Coefficients from Smith (1966) Proc. 6th World Forestry Conference
C     BL Coefficients from Ek (1974) School of Natural Res., U. Wisc., Forestry Res. Notes.
C     PD Coefficients from GC of Paine and Hann (1982) FRL Research Paper 46
C     WI Coefficients from GC of Paine and Hann (1982) FRL Research Paper 46
C
      DATA MCWPAR/
     1           2.320746348,   4.6198    ,   4.5652    ,   4.0       ,! RA,DF,WH,RC
     1           4.0953     ,   2.9793895 ,   2.9793895 ,              ! BL,PD,WI
C
     2           6.661401926,   1.8426    ,   1.4147    ,   1.65      ,! RA,DF,WH,RC
     2           2.3849     ,   1.5512443 ,   1.5512443 ,              ! BL,PD,WI
C
     3           0.0        ,  -0.011311  ,   0.0       ,   0.0       ,! RA,DF,WH,RC
     3          -0.011630   ,  -0.01416129,  -0.01416129,              ! BL,PD,WI
C
     4           0.6        ,   1.0       ,   1.0       ,   1.0       ,! RA,DF,WH,RC
     4           1.0        ,   1.0       ,   1.0       ,              ! BL,PD,WI
C
     5         999.99       ,  81.45      , 999.99      , 999.99      ,! RA,DF,WH,RC
     5         102.53       ,  54.77      ,  54.77/                    ! BL,PD,WI
C
      DBH=D
      HT=H
      B0=MCWPAR(ISPGRP,1)
      B1=MCWPAR(ISPGRP,2)
      B2=MCWPAR(ISPGRP,3)
      K=MCWPAR(ISPGRP,4)
      PKDBH=MCWPAR(ISPGRP,5)
      IF(DBH .GT. PKDBH) THEN
         DBH=PKDBH
      ENDIF
      IF(HT .LT. 4.501)THEN
           MCW=HT/4.5*B0
      ELSE
           MCW=B0+B1*DBH**K+B2*DBH**2
      ENDIF
      RETURN
      END
C
